
Foreman - Feature #944

Provide a mechanism to clear a host's network conflicts

05/26/2011 03:20 AM - Paul Kelly

Status: Closed   

Priority: Normal   

Assignee: Paul Kelly   

Category: Orchestration   

Target version: 1.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

If a host fails to build because there are network conflicts, e.g. there is already a DNS entry for this host, then provide a way to

resolve the problem.

Related issues:

Related to Foreman - Feature #786: Add the option to use existing DHCP reserv... Closed 03/24/2011

Related to Foreman - Bug #1101: DHCP complains about conflict when machine al... Closed 08/09/2011

Related to Smart Proxy - Bug #1270: Deleting Host or Updating IP address Give... Closed 10/27/2011

Blocked by Smart Proxy - Feature #1023: Handle DNS and DHCP collissions as a ... Closed 07/03/2011

Blocked by Foreman - Refactor #1120: convert dhcp handling to real network ob... Closed 08/18/2011

Blocked by Foreman - Refactor #1121: convert dns handling to real network obj... Closed 08/18/2011

Associated revisions

Revision 117ba92a - 12/19/2011 08:14 AM - Paul Kelly

Fixes #944 - clear network conflicts

When a network conflict is detected (such as conflicting ip/name dns or

dhcp records), foreman would try to suggest a resolution.

Signed-off-by: Paul Kelly <paul.ian.kelly@googlemail.com>

Revision 0355a1c1 - 12/19/2011 09:53 AM - Ohad Levy

fixes typo - refs #944

Revision a21f5e98 - 12/20/2011 01:55 AM - Ohad Levy

Revert "fixes typo - refs #944"

This reverts commit 0355a1c1326779dbb21ab91f1b93b0405816f12a.

Revision ac36e7ce - 12/20/2011 01:55 AM - Ohad Levy

Revert "Fixes #944 - clear network conflicts"

This reverts commit 117ba92a758e4589ef5fdf1f1b9083402b2d317b.

Revision 30ae12bf - 03/15/2012 10:28 AM - Ohad Levy

Fixes #944 - clear network conflicts

When a network conflict is detected (such as conflicting ip/name dns or

dhcp records), foreman would try to suggest a resolution.

Signed-off-by: Paul Kelly <paul.ian.kelly@googlemail.com>

History

#1 - 06/17/2011 09:07 AM - Paul Kelly
- Status changed from New to Ready For Testing

- Assignee set to Paul Kelly

#2 - 06/20/2011 10:00 AM - Paul Kelly

rebased and tested

#3 - 07/15/2011 05:28 AM - Paul Kelly

I have pushed the branch to my github as I added your requests as a separate commit, for easy viewing.

#4 - 08/13/2011 01:11 PM - Paul Kelly

Another complete rewrite but this time I think you will like it

I have not extensively tested it but see if the code is suitable before I expend all that time

#5 - 08/17/2011 03:57 AM - Paul Kelly

- Category set to Orchestration

- Assignee changed from Paul Kelly to Ohad Levy

#6 - 12/13/2011 11:26 AM - Paul Kelly

A new implementation is on the way. A couple of point might make this code more easy to understand.

1 I had to reorder the DNS and DHCP operations so that DNS went first. This is because conflict in DNS validations would cause the queue to never

get run and DHCP conflicts would never be tested for. If DNS conflicts are detected then a DHCP collision test is performed. This is only done when

there are DNS collisions or if we are forcing foreman to overwrite the network data as this is a slooooow operation for native MS.

2) When overwriting the network data we do not consider collisions as fatal errors

One other point; I cannot think of any suitable name for this operation

overwrite? ? errors.are_all_conflicts? : errors.empty?

 If you can, then please refactor the damn thing.

#7 - 12/16/2011 05:37 AM - Paul Kelly

Added support for conflicting DHCP leases and for displaying conflict errors in the GUI

#8 - 12/19/2011 08:17 AM - Ohad Levy

- Target version set to 1.0

#9 - 12/19/2011 09:17 AM - Paul Kelly

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 117ba92a758e4589ef5fdf1f1b9083402b2d317b.

#10 - 12/20/2011 02:00 AM - Ohad Levy

- Status changed from Closed to Assigned

- Assignee changed from Ohad Levy to Paul Kelly

sadly i've reverted this patch as well, it seems like it breaks the orchestation code, and I had little time to dig in.

in general, I think we need to break down the methods that decided if a task needs to be triggered or not, I've seen some examples (with the patch

applied) where some tasks / rollback tasks are still performed even if there are errors etc.

I would suggest something like:

def in_rollback?

  queue.tasks.select{|t| t.type == "rolebacked"}.any?

end

 
def allowed_to_add_new_tasks?

..
end

 etc

#11 - 12/20/2011 03:40 AM - Ohad Levy

- Status changed from Assigned to Closed

Applied in changeset ac36e7ce627de142961b22fca57db9d6412b9aa1.

#12 - 01/10/2012 05:38 AM - Ohad Levy

- Status changed from Closed to New

as this was reverted, the ticket is reopened

#13 - 03/15/2012 11:13 AM - Ohad Levy

- Status changed from New to Closed

Applied in changeset 30ae12bf50633dde28d785e0f8fe9bbbc497c76f.
